local object, tile_quads = ...
local Unit = require("objects.Units.Unit")

local fr_walking_plank_east = {
	tile_quads[1985], tile_quads[1986], tile_quads[1987],
	tile_quads[1988], tile_quads[1989], tile_quads[1990],
	tile_quads[1991], tile_quads[1992]
}
local fr_walking_plank_north = {
	tile_quads[1993], tile_quads[1994], tile_quads[1995],
	tile_quads[1996], tile_quads[1997], tile_quads[1998],
	tile_quads[1999], tile_quads[2000]
}
local fr_walking_plank_west = {
	tile_quads[2041], tile_quads[2042], tile_quads[2043],
	tile_quads[2044], tile_quads[2045], tile_quads[2046],
	tile_quads[2047], tile_quads[2048]
}
local fr_walking_plank_south = {
	tile_quads[2017], tile_quads[2018], tile_quads[2019],
	tile_quads[2020], tile_quads[2021], tile_quads[2022],
	tile_quads[2023], tile_quads[2024]
}
local fr_walking_plank_northeast = {
	tile_quads[2001], tile_quads[2002], tile_quads[2003],
	tile_quads[2004], tile_quads[2005], tile_quads[2006],
	tile_quads[2007], tile_quads[2008]
}
local fr_walking_plank_northwest = {
	tile_quads[2009], tile_quads[2010], tile_quads[2011],
	tile_quads[2012], tile_quads[2013], tile_quads[2014],
	tile_quads[2015], tile_quads[2016]
}
local fr_walking_plank_southeast = {
	tile_quads[2025], tile_quads[2026], tile_quads[2027],
	tile_quads[2028], tile_quads[2029], tile_quads[2030],
	tile_quads[2031], tile_quads[2032]
}
local fr_walking_plank_southwest = {
	tile_quads[2033], tile_quads[2034], tile_quads[2035],
	tile_quads[2036], tile_quads[2037], tile_quads[2038],
	tile_quads[2039], tile_quads[2040]
}
local fr_walking_east = {
	tile_quads[2201],tile_quads[2202],tile_quads[2203],
	tile_quads[2204],tile_quads[2205],tile_quads[2206],
	tile_quads[2207],tile_quads[2208]
}
local fr_walking_north = {
	tile_quads[2209],tile_quads[2210],tile_quads[2211],
	tile_quads[2212],tile_quads[2213],tile_quads[2214],
	tile_quads[2215],tile_quads[2216]
}
local fr_walking_northeast = {
	tile_quads[2217],tile_quads[2218],tile_quads[2219],
	tile_quads[2220],tile_quads[2221],tile_quads[2222],
	tile_quads[2223],tile_quads[2224]
}
local fr_walking_northwest = {
	tile_quads[2225],tile_quads[2226],tile_quads[2227],
	tile_quads[2228],tile_quads[2229],tile_quads[2230],
	tile_quads[2231],tile_quads[2232]
}
local fr_walking_south = {
	tile_quads[2233],tile_quads[2234],tile_quads[2235],
	tile_quads[2236],tile_quads[2237],tile_quads[2238],
	tile_quads[2239],tile_quads[2240]
}
local fr_walking_southeast = {
	tile_quads[2241],tile_quads[2242],tile_quads[2243],
	tile_quads[2244],tile_quads[2245],tile_quads[2246],
	tile_quads[2247],tile_quads[2248]
}
local fr_walking_southwest = {
	tile_quads[2249],tile_quads[2250],tile_quads[2251],
	tile_quads[2252],tile_quads[2253],tile_quads[2254],
	tile_quads[2255],tile_quads[2256]
}
local fr_walking_west = {
	tile_quads[2257],tile_quads[2258],tile_quads[2259],
	tile_quads[2260],tile_quads[2261],tile_quads[2262],
	tile_quads[2263],tile_quads[2264]
}
local fr_cutting_northeast = { --note actually north
	tile_quads[2056],tile_quads[2057],tile_quads[2058],
	tile_quads[2059],tile_quads[2060],tile_quads[2061],
	tile_quads[2062],tile_quads[2063]
}

		local Woodcutter = class('Woodcutter', Unit)
			function Woodcutter:initialize(cx,cy,i,o,x,y,type)
				Unit.initialize(self,cx,cy,i,o,x,y,type, "No trees")
				self.state = 'Looking to chop tree'
				self.marked = 0
				self.count = 1
				self.timr = 0
				self.target_tree = 0
				self.cut = function() 
					if self.state == "Cutting down" then
						--print("Trying to cut down "..self.target_tree.type)
						local tree_progress = 0
						if self.target_tree.type == "Pine tree" then
						tree_progress = self.target_tree:cut() else 
						self.state = "Looking to chop tree"	
							self.move_dir = "none"
						end
						if tree_progress == 2 then
							--self.animation = anim.newAnimation(fr_walking_north,0.15)
							self.i = (self.fx*0.001)%chunk_width
							self.o = (self.fy*0.001)%chunk_width
							self.move_dir = "none"
							self.count = 1
							tree_progress = 3			
								if _G.stockpile then
                                    self.state = "Going to stockpile"    
                                    local closest_node
                                    local distance = math.huge
                                    for k,v in ipairs(_G.stockpile.node_list) do
                                        local tmp = manhattan_distance(v.gx,v.gy,self.gx,self.gy)
                                        if tmp < distance then
                                            distance = tmp
                                            closest_node = v
                                        end
                                    end
                                    if not closest_node then self.state = "Looking to chop tree" else                                    
                                    self:requestPath(closest_node.gx,closest_node.gy) end
                                else self.state = "Looking to chop tree" end
						end
					else --print("State", self.state)
					end					
				end
				self.animation = anim.newAnimation(fr_walking_west,10)		
			end 
			function Woodcutter:check_trees(cx,cy)
				local chunkx,chunky = cx or self.cx,cy or self.cy 
				local closest_object, closest_distance = nil,10000000
				if _G.chunk_objects[chunkx][chunky] then
					for index, obj in ipairs ( _G.chunk_objects[chunkx][chunky] ) do 
						if obj.type == 'Pine tree' and obj.marked == false then
							if obj.gx > 0 and obj.gx < 2048 and obj.gy > 0 and obj.gy < 2048 then --and _G.nodes[obj.gx][obj.gy+1].walkable == 0 then --fixme
								local dist = manhattan_distance(self.gx,self.gy, obj.gx, obj.gy)
								if dist < closest_distance then 
									closest_object = obj
									closest_distance = dist
								end
							end
						end
					end
				end
				if not closest_object then return false,false else return closest_object,closest_distance end
			end
			function Woodcutter:find_tree()
				local closest_object, closest_distance = nil,10000000
				local objt,disto
					objt,disto = self:check_trees(self.cx,self.cy)
					if disto and disto < closest_distance then  
							closest_object = objt
							closest_distance = disto
					end
					objt,disto = self:check_trees(self.cx+1,self.cy)
					if disto and disto < closest_distance then  
							closest_object = objt
							closest_distance = disto
					end
					objt,disto = self:check_trees(self.cx+1,self.cy+1)
					if disto and disto < closest_distance then  
							closest_object = objt
							closest_distance = disto
					end
					objt,disto = self:check_trees(self.cx+1,self.cy-1)
					if disto and disto < closest_distance then  
							closest_object = objt
							closest_distance = disto
					end
					objt,disto = self:check_trees(self.cx-1,self.cy+1)
					if disto and disto < closest_distance then  
							closest_object = objt
							closest_distance = disto
					end
					objt,disto = self:check_trees(self.cx-1,self.cy)
					if disto and disto < closest_distance then  
							closest_object = objt
							closest_distance = disto
					end
					objt,disto = self:check_trees(self.cx-1,self.cy-1)
					if disto and disto < closest_distance then  
							closest_object = objt
							closest_distance = disto
					end
					objt,disto = self:check_trees(self.cx,self.cy+1)
					if disto and disto < closest_distance then  
							closest_object = objt
							closest_distance = disto
					end
					objt,disto = self:check_trees(self.cx,self.cy-1)
					if disto and disto < closest_distance then  
							closest_object = objt
							closest_distance = disto
					end
				if not closest_object then print("No trees nearby!") self.state = "No trees" return end
				self.target_tree = closest_object 
				--print("Target tree:", self.target_tree)
				self.endx = closest_object.gx
				self.endy = closest_object.gy+1
				self:requestPath(self.endx,self.endy) 
				--print("Found tree at "..self.endx.."  "..self.endy)
					self.state = "Going to tree"
					closest_object.marked = true
			end
			function Woodcutter:dir_sub_update(dir)
				if dir == "west" then
                    if self.state == "Going to stockpile" then
                        self.animation = anim.newAnimation(fr_walking_plank_west,0.11) 
                    else
                        self.animation = anim.newAnimation(fr_walking_west,0.11)
                    end
				elseif dir == "southwest" then
                    if self.state == "Going to stockpile" then
                        self.animation = anim.newAnimation(fr_walking_plank_southwest,0.11)
                    else
                        self.animation = anim.newAnimation(fr_walking_southwest,0.11)
                    end
				elseif dir == "northwest" then
                    if self.state == "Going to stockpile" then
                        self.animation = anim.newAnimation(fr_walking_plank_northwest,0.11)
                    else
                        self.animation = anim.newAnimation(fr_walking_northwest,0.11)
                    end
				elseif dir == "north" then
                    if self.state == "Going to stockpile" then
                        self.animation = anim.newAnimation(fr_walking_plank_north,0.11)
                    else
                        self.animation = anim.newAnimation(fr_walking_north,0.11)
                    end
				elseif dir == "south" then
                    if self.state == "Going to stockpile" then
                        self.animation = anim.newAnimation(fr_walking_plank_south,0.11)
                    else
                        self.animation = anim.newAnimation(fr_walking_south,0.11)
                    end
				elseif dir == "east" then
                    if self.state == "Going to stockpile" then
                        self.animation = anim.newAnimation(fr_walking_plank_east,0.11)
                    else
                        self.animation = anim.newAnimation(fr_walking_east,0.11)
                    end
				elseif dir == "southeast" then
                    if self.state == "Going to stockpile" then
                        self.animation = anim.newAnimation(fr_walking_plank_southeast,0.11)
                    else
                        self.animation = anim.newAnimation(fr_walking_southeast,0.11)
                    end
				elseif dir == "northeast" then
                    if self.state == "Going to stockpile" then
                        self.animation = anim.newAnimation(fr_walking_plank_northeast,0.11)
                    else
                        self.animation = anim.newAnimation(fr_walking_northeast,0.11)
                    end
				end
			end
			function Woodcutter:update()
				if self.path_state == "Waiting for path" then
					self:pathfind()
				elseif self.state ~= "No trees" then
					if self.state == "Looking to chop tree" then
						self:find_tree()
					elseif self.move_dir == "none" and self.state == "Going to tree" then
						self:update_direction()
					elseif self.move_dir == "none" and self.state == "Going to stockpile" then
						self:update_direction()
					end
					self.timr = self.timr + 1
					self.timr = self.timr % 60
					if self.state == "Going to tree" or self.state == "Going to stockpile" then
						self:move()
					end
					if self.fx*0.001 == self.waypoint_x and self.fy*0.001 == self.waypoint_y and self.move_dir ~= "none" then
						if self.state == "Going to tree" then
							if self.count == self.nd_len then 
								self.state = "Cutting down"
								self.animation = anim.newAnimation(fr_cutting_northeast,0.12,self.cut)
								self.nd = {}
								self.waypoint_x, self.waypoint_y = nil, nil
								self.move_dir = "none"			
								self.count = 1					
								return 
							else
								self.waypoint_x = self.nd[self.count][1]
								self.waypoint_y = self.nd[self.count][2]
								self.move_dir = "none"									
							end
							self.count = self.count + 1
						elseif self.state == "Going to stockpile" then
							if self.count == self.nd_len then
								_G.stockpile:store('wood')
								_G.stockpile:store('wood')
								self.state = "Looking to chop tree"
								self.nd = {}
								self.waypoint_x, self.waypoint_y = nil, nil
								self.move_dir = "none"				
								self.count = 1		
								return 
							else
								self.waypoint_x = self.nd[self.count][1]
								self.waypoint_y = self.nd[self.count][2]
								self.move_dir = "none"									
							end
							self.count = self.count + 1
						end
					end
				end
			end
			function Woodcutter:animate()
				self:update()
				self.animation:update(dt)
			end
return Woodcutter